//
//  SPList+Operations.m
//
//  Copyright (c) 2013 Nathan Wood (http://www.woodnathan.com/)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#import "SPList.h"
#import "SPContext.h"

@implementation SPList (Operations)

- (void)createItemWithFields:(NSDictionary *)fields completion:(void (^)(NSArray *results))completion
{
    [self.context createList:self.listName
              itemWithFields:fields
                     results:completion];
}

- (void)loadItems:(void (^)(NSArray *items))completion
{
    [self.context getList:self.listName
                    items:^(NSArray *items) {
                        self.items = items;
                        
                        if (completion)
                            completion(items);
                    }];
}

- (void)loadFields:(void (^)(NSArray *fields))completion
{
    [self.context getListWithList:self
                       completion:^(SPList *list) {
                           if (completion)
                               completion(self.fields);
                       }];
}

- (void)loadViews:(void (^)(NSArray *views))completion
{
    [self.context getList:self.listName
                    views:^(NSArray *views) {
                        self.views = views;
                        
                        if (completion)
                            completion(views);
                    }];
}

@end